//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ValueToolBar.h"
#include "ValueMenu.h"
#include "../MainFrm.h"
#include "../EditForm/DynControl.h"
#include "OutToDebug.h"
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif



extern CImageList *GetImageList();
extern CMainFrame *pMainFrame;
extern CString csProfileName;
extern TMenuItemArray aAllMenuItems;

void AssignToMenuID(CMenuItem &item,int nId);
int GetUniqueMenuID();
extern CMenuItem GetElementFromValues(CValue **p);


CMethods CValueToolBar::Methods;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNCREATE(CValueToolBar,CValue);

CValueToolBar::CValueToolBar()
{
	nType=100;
	m_pToolBar=0;
}

CValueToolBar::~CValueToolBar()
{
//	if(m_pToolBar)
//		delete m_pToolBar;
}


//******************************
//   
//******************************

static struct 
{
	CValueToolBar::MethFunc caller;
	SEngRus meths;
}  ArrayMethods[]=
{
	{CValueToolBar::GetCount,{"CountItem","",""}},
	{CValueToolBar::AddButton,{"Add","","(,,,,,)"}},
	{CValueToolBar::RemoveButton,{"Remove","","()"}},
	{CValueToolBar::ShowWindow,{"Visible","","()"}},
	{CValueToolBar::GetMainTool,{"GetMainTool","","()"}},
	{CValueToolBar::GetEditTool,{"GetFormTool","","()"}},
	{CValueToolBar::GetModuleTool,{"GetModuleTool","","()"}},
	{CValueToolBar::Name,{"ToolName","","() -      "}},
	{CValueToolBar::GetImage,{"GetImage","","() -    "}},


};
 

#define NMETHODS (sizeof(ArrayMethods)/sizeof(*ArrayMethods) )

void CValueToolBar::PrepareNames(void)
{

	SEngRus aMethods[NMETHODS];
	for(int i=0;i<NMETHODS;i++){
		aMethods[i] = ArrayMethods[i].meths;
	}
	int nCountM=NMETHODS;
	Methods.Prepare(aMethods,nCountM);
}


CValue CValueToolBar::Method(int iName,CValue **p)
{

	CValue Ret;
	if(iName<NMETHODS)
		(this->* ArrayMethods[iName].caller)(Ret,p);
	return Ret;
}

CString CValueToolBar::GetString()
{
	return " ";
}

//////////////////////////////////////////////////////////////////////
void CValueToolBar::Create()
{
	if(pMainFrame)
	if(!m_pToolBar)
	{
		static int count=0;
		count++;
		if(m_csName.IsEmpty())
			m_csName.Format("  %d",count);
		m_pToolBar=new CExtToolControlBar();
		if( !m_pToolBar->Create(
				m_csName,
				pMainFrame,
				MENU_FINISH_ID+count
				)
			)
		{
			AfxMessageBox("Failed to create toolbar\n");
			return;      // fail to create
		}

		m_pToolBar->EnableDocking(CBRS_ALIGN_ANY);
		pMainFrame->DockControlBar(m_pToolBar);



		CWinApp * pApp = ::AfxGetApp();
		CExtControlBar::ProfileBarStateLoad(
			pMainFrame,
			pApp->m_pszRegistryKey,
			csProfileName,
			"Save",
			&pMainFrame->m_dataFrameWP
			);

	}
}

//////////////////////////////////////////////////////////////////////
void CValueToolBar::Attach(class CExtToolControlBar	*m_pTool)
{
	m_pToolBar=m_pTool;
}



//////////////////////////////////////////////////////////////////////
//  
//////////////////////////////////////////////////////////////////////

BOOL CValueToolBar::AddButton(CValue &rez,CValue**p)
{
	Create();
	int nImage=p[0]->GetNumber();

	CMenuItem element=GetElementFromValues(p);
	if(nImage<0)
	{
		m_pToolBar->InsertButton();
		return TRUE;
	}

	UINT nID=0;

	//     
	if(nImage)
	for(int i=0;i<m_pToolBar->GetButtonsCount();i++)
	{
		CExtBarButton * pButton=m_pToolBar->GetButton( i );
		UINT nStyle;
		if(pButton)
		{
			m_pToolBar->GetButtonInfo(i,nID,nStyle);
			if(nID>0 && nID<MENU_FINISH_ID)
			if(pButton->m_nData==nImage)
			{
				if(!m_pToolBar->RemoveButton(i))
					Error("  ");
				break;
			}
		}
		nID=0;
	}


	//   (    )
	if(nID==0)
		nID=GetUniqueMenuID();
	AssignToMenuID(element,nID);


	CExtCmdItem item;
	item.m_nCmdID=nID;
	item.m_sToolbarText=p[3]->GetString();
	item.m_sTipTool=p[4]->GetString();
	item.m_sTipStatus=p[5]->GetString();


	CImageList *pImageList=GetImageList();
	if(!pImageList)
		return 1;
	HICON hIcon = pImageList->ExtractIcon( nImage );
	if(!hIcon)
		Error("     ");
	
	g_CmdManager->CmdSetup(csProfileName,item,1);
	g_CmdManager->CmdSetIcon(csProfileName,item.m_nCmdID,hIcon);

	BOOL bRes=m_pToolBar->InsertButton(-1,item.m_nCmdID,1,nImage);
	return TRUE;
};

BOOL CValueToolBar::GetCount(CValue &rez,CValue**p)
{
	Create();
	rez=m_pToolBar->GetButtonsCount();
	return TRUE;
};
BOOL CValueToolBar::ShowWindow(CValue &rez,CValue**p)
{
	Create();
	m_pToolBar->ShowWindow(p[0]->GetNumber());
	return TRUE;
};
BOOL CValueToolBar::RemoveButton(CValue &rez,CValue**p)
{
	Create();
	int nIndex=p[0]->GetNumber()-1;
	if(nIndex<0 || nIndex>=m_pToolBar->GetButtonsCount())
		Error("    ");

	m_pToolBar->RemoveButton(nIndex);
	return TRUE;
};
BOOL CValueToolBar::GetMainTool(CValue &rez,CValue**p)
{

	rez.CreateObject(GetTypeString());
	((CValueToolBar*)rez.pRef)->Attach(&pMainFrame->m_ToolMain);
	((CValueToolBar*)rez.pRef)->m_csName="  ";
	return TRUE;
};

BOOL CValueToolBar::GetModuleTool(CValue &rez,CValue**p)
{

	rez.CreateObject(GetTypeString());
	((CValueToolBar*)rez.pRef)->Attach(&pMainFrame->m_ToolModule);
	((CValueToolBar*)rez.pRef)->m_csName="  ";
	return TRUE;
};

BOOL CValueToolBar::GetEditTool(CValue &rez,CValue**p)
{

	rez.CreateObject(GetTypeString());
	((CValueToolBar*)rez.pRef)->Attach(&pMainFrame->m_ToolEdit);
	((CValueToolBar*)rez.pRef)->m_csName="  ";
	return TRUE;
};

BOOL CValueToolBar::Name(CValue &rez,CValue**p)
{
	rez=String(m_csName);
	m_csName=p[0]->GetString();
	return TRUE;
};

BOOL CValueToolBar::GetImage(CValue &rez,CValue**p)
{
	Create();
	int nIndex=p[0]->GetNumber()-1;
	if(nIndex<0 || nIndex>=m_pToolBar->GetButtonsCount())
		Error("    ");

	CExtBarButton * pButton=m_pToolBar->GetButton( nIndex );
	if(pButton)
	{
		rez=pButton->m_nData;
	}
	return TRUE;
};